<?php
/**
 * sh404SEF support for com_eventboooking component.
 * @author      Tuan Pham Ngoc
 * @copyright   Ossolution Team - 2010-2011
 * @package     Event Booking
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

defined( '_JEXEC' ) or die ;

// ------------------  standard plugin initialize function - don't change ---------------------------
global $sh_LANG;
$sefConfig = & shRouter::shGetConfig();
$shLangName = '';
$shLangIso = '';
$title = array();
$shItemidString = '';
$dosef = shInitializePlugin( $lang, $shLangName, $shLangIso, $option);
if ($dosef == false) return;
// ------------------  standard plugin initialize function - don't change ---------------------------

// ------------------  load language file - adjust as needed ----------------------------------------
//$shLangIso = shLoadPluginLanguage( 'com_eventbooking', $shLangIso, '_SH404SEF_EVENTBOOKING_EVENTS');
// ------------------  load language file - adjust as needed ----------------------------------------

require_once JPATH_ROOT.'/components/com_dms/helper/helper.php';
$db = & JFactory::getDbo() ;
DMSHelper::loadLanguage();
$config = DMSHelper::getConfig();			
$lang = & JFactory::getLanguage() ;
$tag = $lang->getTag() ;
if(!$tag)
    $shLangIso = 'en';
else {
    $tagArr = explode('-', $tag) ;
    $shLangIso = $tagArr[0] ;
}    	
if (!function_exists('shDMSDocumentTitle')) {
    
  function shDMSDocumentTitle($documentId, $option, $shLangName) {
    if (empty($documentId)) return '';
    $sefConfig = & shRouter::shGetConfig();
    $config = DMSHelper::getConfig() ;
    // get DB
    $database =& JFactory::getDBO();

    $database->setQuery('SELECT title FROM #__dms_documents WHERE id = '.$database->Quote( $documentId));
    if (!shTranslateUrl($option, $shLangName))  // V 1.2.4.m
        $result = $database->loadObject( false);
    else 
        $result= $database->loadObject();    
    return empty($result) ? '' :
    ($config->insert_document_id ? $documentId.$sefConfig->replacement.$result->title : $result->title);
  }
  
}


if( !function_exists( 'dms_sef_get_category_array' ) ){
  function dms_sef_get_category_array( $category_id, $option, $shLangName ){

    global $shMosConfig_locale;
    $sefConfig = & shRouter::shGetConfig();
    
    $config = DMSHelper::getConfig() ;

    // get DB
    $database = & JFactory::getDBO();

    static $DMtree = null;
     
    if(empty($DMtree[$shMosConfig_locale])){
      $q  = "SELECT id, name, parent FROM #__dms_categories" ;  // load them all in memory
      $database->setQuery( $q );
      if (!shTranslateUrl($option, $shLangName))  // V 1.2.4.m
          $DMtree[$shMosConfig_locale] = $database->loadObjectList( 'id', false);  // V 1.2.4.m if Joomfish, and don't translate
          // use special call of loadObjectList, asking JF not to translate
      else
          $DMtree[$shMosConfig_locale] = $database->loadObjectList( 'id' );
    }
    $title = array();
    if ($config->insert_category == 1)    // only one category
        $title[] = ($config->insert_category_id ?
            $DMtree[$shMosConfig_locale][ $category_id ]->id.$sefConfig->replacement : '')
            .$DMtree[$shMosConfig_locale][ $category_id ]->name;
    else
    do {               
      $title[] = ($config->insert_category_id ?
      $DMtree[$shMosConfig_locale][ $category_id ]->id.$sefConfig->replacement : '') // to category
      .$DMtree[$shMosConfig_locale][ $category_id ]->name;                           // will always be unique
      $category_id = $DMtree[$shMosConfig_locale][ $category_id ]->parent ;
    } while( $category_id != 0 );
    return array_reverse( $title );
  }
}

$task = isset($task) ? @$task : null;
$view = isset($view) ? @$view : null ;

switch ($view) {
   case 'categories' :
        $task = 'view_categories' ;
        break ;
    case 'category' :
        $task = 'view_category' ;
        break ;    
    case 'complete' :
        $task = 'order_complete' ;
        break ;  
    case 'failure' :
        $task = 'order_failure' ;
        break ;   
    case 'cart' :
        $task = 'view_cart' ;
        break ;          
        break ;      
    case 'mydocs' :
        $task = 'order_history' ;
        break ;         
    case 'docs' :
        $task = 'my_documents' ;
        break ;
    case 'doc' :
        $task = 'submit_document' ;
        break ;                    
}
          
$Itemid = isset($Itemid) ? @$Itemid : null;  // V 1.2.4.t

//Insert component name from menu
$dmsTitle = shGetComponentPrefix($option);
$dmsTitle = empty($dmsTitle) ?  getMenuTitle($option, null, $Itemid, null, $shLangName )
: $dmsTitle;
$dmsTitle = (empty($dmsTitle) || $dmsTitle == '/') ? 'Documents':$dmsTitle; // V 1.2.4.t

if ($config->insert_menu_title && !empty($dmsTitle)) $title[] = $dmsTitle ;
 
switch ($task)
{
  case 'view_categories':
  case 'view_category' :
    if (!empty($category_id))
        $title = array_merge( $title, dms_sef_get_category_array( $category_id, $option, $shLangName));
        $title[] = JText::_('DMS_SEF_VIEW_CAT');
        break;            
  case 'view_document' :
  case 'add_to_cart' :
  case 'doc_download' :
  case 'download_form' :       
       if (!empty($id)) {
           $title[] = shDMSDocumentTitle($id, $option, $shLangName);
       } 
       $languageItem = 'DMS_SEF_'.strtoupper($task) ;
       $title[] = JText::_($languageItem) ;
       shRemoveFromGETVarsList('id');
       break ;   
  case 'checkout' :            
  case 'order_complete' :
  case 'order_failure' :                      
  case 'view_cart' :    
  case 'download' :          
      $languageItem = 'DMS_SEF_'.strtoupper($task) ;
      $title[] = JText::_($languageItem) ;      
      break ;        
  case 'order_history' :
  case 'my_documents' :
  case 'submit_document' :
      if (!$config->insert_menu_title) {                    
          $languageItem = 'DMS_SEF_'.strtoupper(task) ;
          $title[] = JText::_($languageItem) ;    
      }                  
      break ;   
  default:
    $dosef = false;
    break;
}

shRemoveFromGETVarsList('option');
if (isset($lang))
shRemoveFromGETVarsList('lang');
if (isset($Itemid))
shRemoveFromGETVarsList('Itemid');
if (isset($task))
shRemoveFromGETVarsList('task');
if (isset($view))
    shRemoveFromGETVarsList('view');
if (isset($category_id))
    shRemoveFromGETVarsList('category_id');        

// ------------------  standard plugin finalize function - don't change ---------------------------
if ($dosef){
  $string = shFinalizePlugin( $string, $title, $shAppendString, $shItemidString,
  (isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null),
  (isset($shLangName) ? @$shLangName : null));
}
// ------------------  standard plugin finalize function - don't change ---------------------------

?>